<template>
  <div class="app-container">
    <el-form :model="queryParams" ref="queryForm" :inline="true" v-show="showSearch" label-width="68px">
      <el-form-item label="附件名称" prop="fileName">
        <el-input
          v-model="queryParams.fileName"
          placeholder="请输入附件名称"
          clearable
          size="small"
          @keyup.enter.native="handleQuery"
        />
      </el-form-item>
      <el-form-item>
        <el-button type="cyan" icon="el-icon-search" size="mini" @click="handleQuery">搜索</el-button>
        <el-button icon="el-icon-refresh" size="mini" @click="resetQuery">重置</el-button>
      </el-form-item>
    </el-form>

    <el-row :gutter="10" class="mb8">
      <el-col :span="1.5">
        <el-button
          type="success"
          icon="el-icon-s-promotion"
          size="mini"
          @click="handleApprove"
          v-if="isApprove==0"
          v-hasPermi="['pssr:overhaulExchanger:edit']"
        >发起审批
        </el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button
          type="primary"
          icon="el-icon-upload"
          size="mini"
          v-hasPermi="['pssr:instrumentTest:add']"
          @click="handleDoc"
          v-if="isApprove==0"
        >附件
        </el-button>
      </el-col>
      <right-toolbar :showSearch.sync="showSearch" @queryTable="getList"></right-toolbar>
    </el-row>

    <el-table v-loading="loading" :data="instrumentTestList" @selection-change="handleSelectionChange"
              :height="clientHeight" border>
      <el-table-column type="selection" width="55" align="center"/>
      <el-table-column label="审批状态" align="center" prop="approveStatus" width="100">
        <template slot-scope="scope">
          <el-tag v-if="scope.row.approveStatus==0">未审批</el-tag>
          <el-tag v-if="scope.row.approveStatus==2" type="success">已确认</el-tag>
        </template>
      </el-table-column>
      <el-table-column label="附件名称" align="center" prop="fileName" :show-overflow-tooltip="true">
        <template slot-scope="scope">
          <a class="link-type" @click="handleDownload(scope.row)">
            <span>{{ scope.row.fileName }}</span>
          </a>
        </template>
      </el-table-column>
      <el-table-column label="备注" align="center" prop="remarks" width="180" :show-overflow-tooltip="true"/>
      <el-table-column label="操作" v-if="isApprove==0" align="center" width="120"
                       class-name="small-padding fixed-width">
        <template slot-scope="scope">
          <el-button
            size="mini"
            type="text"
            icon="el-icon-edit"
            @click="handleUpdate(scope.row)"
            v-hasPermi="['pssr:instrumentTest:edit']"
          >修改
          </el-button>
          <el-button
            size="mini"
            type="text"
            icon="el-icon-delete"
            @click="handleDelete(scope.row)"
            v-hasPermi="['pssr:instrumentTest:remove']"
          >删除
          </el-button>
        </template>
      </el-table-column>
    </el-table>

    <pagination
      v-show="total>0"
      :total="total"
      :page.sync="queryParams.pageNum"
      :limit.sync="queryParams.pageSize"
      @pagination="getList"
    />

    <!-- 添加或修改仪联锁测试对话框 -->
    <el-dialog :close-on-click-modal="false" :title="title" :visible.sync="open" width="500px" append-to-body>
      <el-form ref="form" :model="form" :rules="rules" label-width="80px">
        <el-form-item label="附件名称" prop="fileName">
          <el-input v-model="form.fileName" disabled placeholder="请输入附件名称"/>
        </el-form-item>
        <el-form-item label="备注" prop="remarks">
          <el-input v-model="form.remarks" placeholder="请输入备注"/>
        </el-form-item>
      </el-form>
      <div slot="footer" class="dialog-footer">
        <el-button type="primary" @click="submitForm">确 定</el-button>
        <el-button @click="cancel">取 消</el-button>
      </div>
    </el-dialog>

    <!-- 附件对话框 -->
    <el-dialog :close-on-click-modal="false" v-dialogDrag :title="doc.title" :visible.sync="doc.open"
               append-to-body width="500px" style="text-align: center">
      <el-upload
        ref="doc"
        :limit="50"
        :headers="doc.headers"
        :action="doc.url + '?subId=' + subId "
        :disabled="doc.isUploading"
        :on-progress="handleFileDocProgress"
        :on-success="handleFileDocSuccess"
        :auto-upload="true"
        drag
      >
        <i class="el-icon-upload"></i>
        <div class="el-upload__text">
          将文件拖到此处，或
          <em>点击上传</em>
        </div>
      </el-upload>

      <div slot="footer" class="dialog-footer">
        <el-button @click="doc.open = false">返 回</el-button>
      </div>
    </el-dialog>

    <el-dialog :close-on-click-modal="false" v-dialogDrag :title="pdf.title" :visible.sync="pdf.open" width="1300px"
               append-to-body>
      <div style="margin-top: -60px;float: right;margin-right: 40px;">
        <el-button size="mini" type="text" @click="openPdf">新页面打开PDF</el-button>
      </div>
      <div style="margin-top: -30px">
        <iframe :src="pdf.pdfUrl" frameborder="0" width="100%" height="700px"></iframe>
      </div>
    </el-dialog>
  </div>
</template>

<script>
import {
  addInstrumentTest,
  delInstrumentTest,
  exportInstrumentTest,
  getInstrumentTest,
  importTemplate,
  listInstrumentTest,
  updateInstrumentTest,
  updateInstrumentTestBatch
} from "@/api/pssr/instrumentTest";
import {treeselect} from "@/api/system/dept";
import {getToken} from "@/utils/auth";
import Treeselect from "@riophae/vue-treeselect";
import "@riophae/vue-treeselect/dist/vue-treeselect.css";
import {doApprove} from "@/api/pssr/approve";
import {updateMaterialBatch} from "@/api/pssr/material";

export default {
  dicts: ['pssr_approve_status'],
  name: "InstrumentTest",
  components: {Treeselect},
  props: {
    subId: {
      type: Number,
      default: 0
    },
    isApprove: {
      type: Number,
      default: 0
    },
  },
  data() {
    return {
      doc: {
        file: "",
        // 是否显示弹出层（报告附件）
        open: false,
        // 弹出层标题（报告附件）
        title: "附件",
        // 是否禁用上传
        isUploading: false,
        // 是否更新已经存在的用户数据
        updateSupport: 0,
        // 报告附件上传位置编号
        ids: 0,
        // 设置上传的请求头部
        headers: {Authorization: "Bearer " + getToken()},
        // 上传的地址
        url: process.env.VUE_APP_BASE_API + "/pssr/instrumentTest/uploadFile",
        commonfileList: null,
        pId: null,
        form: {}
      },
      pdf: {
        title: '',
        pdfUrl: '',
        numPages: null,
        open: false,
        pageNum: 1,
        pageTotalNum: 1,
        loadedRatio: 0,
      },
      // 遮罩层
      loading: true,
      // 选中数组
      ids: [],
      // 非单个禁用
      single: true,
      // 非多个禁用
      multiple: true,
      // 显示搜索条件
      showSearch: false,
      // 总条数
      total: 0,
      // 仪联锁测试表格数据
      instrumentTestList: [],
      // 弹出层标题
      title: "",
      // 部门树选项
      deptOptions: undefined,
      clientHeight: 300,
      // 是否显示弹出层
      open: false,
      openBatch: false,
      // 用户导入参数
      upload: {
        // 是否显示弹出层（用户导入）
        open: false,
        // 弹出层标题（用户导入）
        title: "",
        // 是否禁用上传
        isUploading: false,
        // 是否更新已经存在的用户数据
        updateSupport: 0,
        // 设置上传的请求头部
        headers: {Authorization: "Bearer " + getToken()},
        // 上传的地址
        url: process.env.VUE_APP_BASE_API + "/pssr/instrumentTest/importData"
      },
      // 查询参数
      queryParams: {
        pageNum: 1,
        pageSize: 20,
        subId: this.subId,
        approveId: null,
        fileUrl: null,
        fileName: null,
        createrCode: null,
        createdate: null,
        updaterCode: null,
        updatedate: null,
        deptId: null,
        remarks: null
      },
      // 表单参数
      form: {},
      // 表单校验
      rules: {}
    };
  },
  watch: {
    // 根据名称筛选部门树
    deptName(val) {
      this.$refs.tree.filter(val);
    }
  },
  created() {
    //设置表格高度对应屏幕高度
    this.$nextTick(() => {
      this.clientHeight = document.body.clientHeight - 350
    })
    this.getList();
    this.getTreeselect();
  },
  methods: {
    /** 查询仪联锁测试列表 */
    getList() {
      this.loading = true;
      listInstrumentTest(this.queryParams).then(response => {
        this.instrumentTestList = response.rows;
        this.total = response.total;
        this.loading = false;
      });
    },
    /** 查询部门下拉树结构 */
    getTreeselect() {
      treeselect().then(response => {
        this.deptOptions = response.data;
      });
    },
    // 取消按钮
    cancel() {
      this.open = false;
      this.reset();
    },
    // 表单重置
    reset() {
      this.form = {
        id: null,
        subId: this.subId,
        approveId: null,
        fileUrl: null,
        fileName: null,
        delFlag: null,
        createrCode: null,
        createdate: null,
        updaterCode: null,
        updatedate: null,
        deptId: null,
        remarks: null
      };
      this.resetForm("form");
    },
    /** 搜索按钮操作 */
    handleQuery() {
      this.queryParams.pageNum = 1;
      this.getList();
    },
    /** 重置按钮操作 */
    resetQuery() {
      this.resetForm("queryForm");
      this.handleQuery();
    },
    // 多选框选中数据
    handleSelectionChange(selection) {
      this.ids = selection.map(item => item.id)
      this.single = selection.length !== 1
      this.multiple = !selection.length
    },
    /** 新增按钮操作 */
    handleAdd() {
      this.reset();
      this.open = true;
      this.title = "添加仪联锁测试";
    },
    /** 修改按钮操作 */
    handleUpdate(row) {
      this.reset();
      const id = row.id || this.ids
      getInstrumentTest(id).then(response => {
        this.form = response.data;
        this.open = true;
        this.title = "修改仪联锁测试";
      });
    },
    /** 提交按钮 */
    submitForm() {
      this.$refs["form"].validate(valid => {
        if (valid) {
          if (this.form.id != null) {
            updateInstrumentTest(this.form).then(response => {
              this.msgSuccess("修改成功");
              this.open = false;
              this.getList();
            });
          } else {
            addInstrumentTest(this.form).then(response => {
              this.msgSuccess("新增成功");
              this.open = false;
              this.getList();
            });
          }
        }
      });
    },
    /** 删除按钮操作 */
    handleDelete(row) {
      const ids = row.id || this.ids;
      this.$confirm('是否确认删除?', "警告", {
        confirmButtonText: "确定",
        cancelButtonText: "取消",
        type: "warning"
      }).then(function () {
        return delInstrumentTest(ids);
      }).then(() => {
        this.getList();
        this.msgSuccess("删除成功");
      })
    },
    /** 导出按钮操作 */
    handleExport() {
      const queryParams = this.queryParams;
      this.$confirm('是否确认导出所有仪联锁测试数据项?', "警告", {
        confirmButtonText: "确定",
        cancelButtonText: "取消",
        type: "warning"
      }).then(function () {
        return exportInstrumentTest(queryParams);
      }).then(response => {
        this.download(response.msg);
      })
    },
    /** 导入按钮操作 */
    handleImport() {
      this.upload.title = "用户导入";
      this.upload.open = true;
    },
    /** 下载模板操作 */
    importTemplate() {
      importTemplate().then(response => {
        this.download(response.msg);
      });
    },
    // 文件上传中处理
    handleFileUploadProgress(event, file, fileList) {
      this.upload.isUploading = true;
    },
    // 文件上传成功处理
    handleFileSuccess(response, file, fileList) {
      this.upload.open = false;
      this.upload.isUploading = false;
      this.$refs.upload.clearFiles();
      this.$alert(response.msg, "导入结果", {dangerouslyUseHTMLString: true});
      this.getList();
    },
    // 提交上传文件
    submitFileForm() {
      this.$refs.upload.submit();
    },
    /** 确认按钮操作*/
    handleApprove() {
      doApprove(this.subId).then(res => {
        this.msgSuccess("已发起确认流程");
        this.getList();
      })
    },
    /** 报告附件按钮操作 */
    handleDoc(row, fileType) {
      this.doc.id = row.id;
      this.doc.title = this.$t('附件');
      this.doc.open = true;
      this.$nextTick(() => {
        this.$refs.doc.clearFiles()
      })
    },
    //附件上传中处理
    handleFileDocProgress(event, file, fileList) {
      this.doc.file = file;
      this.doc.isUploading = true;
    },
    //附件上传成功处理
    handleFileDocSuccess(response, file, fileList) {
      this.doc.isUploading = false;
      this.$alert(response.msg, this.$t('上传结果'), {dangerouslyUseHTMLString: true});
      this.getList();
    },
    // 文件下载处理
    handleDownload(row) {
      // var name = row.fileName;
      // var url = row.fileUrl;
      // var suffix = url.substring(url.lastIndexOf("."), url.length);
      // const a = document.createElement('a')
      // a.setAttribute('download', name)
      // a.setAttribute('target', '_blank')
      // a.setAttribute('href', process.env.VUE_APP_BASE_API + url)
      // a.click()
      window.open(process.env.VUE_APP_BASE_API + row.fileUrl);
    },
    openPdf() {
      window.open(this.pdf.pdfUrl);//path是文件的全路径地址
    },
    handleSee(row) {
      this.pdf.open = true
      this.pdf.title = row.fileName
      this.pdf.pdfUrl = process.env.VUE_APP_BASE_API + '/pdf/web/viewer.html?file=' + process.env.VUE_APP_BASE_API + row.fileUrl
    },
    handleBatch(){
      this.reset();
      this.openBatch = true
    },
    // 取消按钮
    cancelBatch() {
      this.openBatch = false;
      this.reset();
    },
    /** 提交按钮 */
    submitFormBatch() {
      this.$refs["form"].validate(valid => {
        if (valid) {
          this.form.ids = this.ids
          updateInstrumentTestBatch(this.form).then(response => {
            this.msgSuccess("修改成功");
            this.openBatch = false;
            this.getList();
          });
        }
      });
    },
  }
};
</script>
